﻿'Title: RC2 = Rotator Controller 2
'Author: H.NAMVA
'original issued on: 2013.12.19 by H.NAMVA 
'         ported from the ITU prefix search which created on 2013.04.06
'         and the Rotator Control Panel which created on 2013.11.18
'last updeted on : 2013.12.21 ver 1.0
'
Option Explicit On
Imports System.IO
Imports System.Data
Imports System.Windows.Forms
Imports MySql.Data.MySqlClient
Imports System.Math


Public Class Form1
    Public strConn As String '= "Database=ham ;User ID=root ;Password=jh4adk ;Data Source=localhost"
    Public ds As New DataSet
    Public latitudeFrom As Double = 34.83880833 'default value
    Public longitudeFrom As Double = -133.69995833 'default value

    Private Azimuth As Integer
    Private RxBuf(1024) As Byte
    Private RxBufLength As Integer
    Private strAzimuth As String = ""
    Private MyCommand As MySqlCommand
    Private Const InitFileName = "\RC2.ini"
    Private ds2 As New DataSet

    Delegate Sub ModifyAzimuthLabel()

    Public Sub New()
        Dim sr As System.IO.StreamReader = Nothing
        Dim sUSER As String = ""
        Dim sPASS As String = ""
        Dim sSERVER As String = ""
        Dim sCOM As String = ""
        Dim buf As String = ""
        Dim ExeFileLocation As String

        InitializeComponent()
        Debug.Print(vbCrLf & vbCrLf & "program started: " & Now())
        ExeFileLocation = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().Location)
        sr = New System.IO.StreamReader(ExeFileLocation & InitFileName)
        Debug.Print((System.Reflection.Assembly.GetExecutingAssembly().Location) & InitFileName)
        Do
            buf = sr.ReadLine()
            If IsNothing(buf) Then
                Exit Do
            End If
            Select Case buf.Substring(0, InStr(buf, ":") - 1)
                Case "[USER]"
                    sUSER = Mid(buf, InStr(buf, ":") + 1)
                Case "[PASS]"
                    sPASS = Mid(buf, InStr(buf, ":") + 1)
                Case "[SERVER]"
                    sSERVER = Mid(buf, InStr(buf, ":") + 1)
                Case "[COMPORT]"
                    sCOM = Mid(buf, InStr(buf, ":") + 1)
            End Select
        Loop
        sr.Close()
        strConn = "Database=ham" & ";User ID=" & sUSER _
                    & ";Password=" & sPASS & ";Data Source=" & sSERVER
        Debug.Print(strConn)
        Debug.Print(sCOM)
        COMPort.PortName = sCOM

    End Sub

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim availableSerialPorts As System.Collections.ObjectModel.ReadOnlyCollection(Of String) = My.Computer.Ports.SerialPortNames
        Try
            If availableSerialPorts.Contains(COMPort.PortName) Then
                If COMPort.IsOpen Then
                    MessageBox.Show(COMPort.PortName & " is already OPENED", "error", _
                                    MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Me.Close()
                Else
                    COMPort.Open()
                End If
            Else
                MsgBox(COMPort.PortName & " is not available")
                Me.Close()
            End If
        Catch ex As Exception
            Debug.Print(ex.Message & " in Form1_Load")
            Me.Close()
        End Try

        Debug.Print(vbCrLf & vbCrLf & "program started " & Now)
        LbPrefix.Items.Clear()
        Try
            If DataBaseModule.FillTable(ds2, "MyLocation", strConn) Then
                latitudeFrom = ds2.Tables("MyLocation").Rows(0).Item("latitude")
                longitudeFrom = ds2.Tables("MyLocation").Rows(0).Item("longitude") * -1.0
                Debug.Print("lat = " & latitudeFrom.ToString)
                Debug.Print("lon = " & longitudeFrom.ToString)
            Else
                MsgBox("Database MyLocation is not found")
            End If
            If DataBaseModule.FillTable(ds2, "DXCCprefix2", strConn) = False Then
                MsgBox("Database DXCCprefix2 is not found")
            End If
        Catch ex As Exception
            MsgBox("Invalid Data in the Mylocation table")
            latitudeFrom = 0.0
            longitudeFrom = 0.0
        End Try

    End Sub

    Private Sub AstrCheck(ByRef strAlias As String, ByVal prefix As String)
        Dim start As String = strAlias
        Dim posAstr As Integer
        Dim chArray As Char() = prefix.ToCharArray

        posAstr = strAlias.IndexOf("*")
        If (posAstr > 0) And (prefix.Length >= 2) Then
            If prefix.Length = 2 Then
                If Char.IsNumber(chArray(1)) Then
                    strAlias = strAlias.Replace("*"c, chArray(1))
                Else
                    strAlias = strAlias.Replace("*"c, "1"c)
                End If
            ElseIf prefix.Length >= 3 Then
                If Char.IsNumber(chArray(2)) Then
                    strAlias = strAlias.Replace("*"c, chArray(2))
                Else
                    strAlias = strAlias.Replace("*"c, "1"c)
                End If
            End If
        End If
    End Sub

    Public Sub CourseDistance(ByVal latitudeTo As Double, ByVal longitudeTo As Double, ByRef course As Double, ByRef distance As Double)
        Dim from_x As Double 'lon1(rad) W(+)/E(-)
        Dim from_y As Double 'lat1(rad) N(+)/S(-)
        Dim to_x As Double   'lon2(rad) W(+)/E(-)
        Dim to_y As Double   'lat2(rad) N(+)/S(-)
        Dim DeltaX As Double

        from_x = longitudeFrom * Math.PI / 180
        from_y = latitudeFrom * Math.PI / 180
        to_x = longitudeTo * Math.PI / 180
        to_y = latitudeTo * Math.PI / 180
        DeltaX = from_x - to_x
        distance = 6371.0 * Acos(Sin(from_y) * Sin(to_y) + Cos(from_y) * Cos(to_y) * Cos(DeltaX))
        course = Atan2(Sin(DeltaX) * Cos(to_y), _
                          Cos(from_y) * Sin(to_y) - Sin(from_y) * Cos(to_y) * Cos(DeltaX))
        course = 180 * course / Math.PI
        If course < 0 Then
            course = 360.0 + course
        End If

    End Sub


    Private Function searchDXCC(ByVal prefix As String, ByRef aliasPrefix As String) As Integer
        'Dim conDB As New MySqlConnection
        Dim strCond As String
        Dim rows, i As Integer
        Dim distance As Integer
        Dim course As Integer
        Dim longPath As Integer

        ds.Clear()
        strCond = "where prefix = '" & prefix & "'"
        If DataBaseModule.FillTablePartial(ds, "DXCCprefix2", "*", strCond, strConn) = True Then
            aliasPrefix = ds.Tables("DXCCprefix2").Rows(0).Item("alias")
            Debug.Print("search DXCC by " & prefix & ", alias is " & aliasPrefix)
            If aliasPrefix = "" Then
                rows = ds.Tables("DXCCprefix2").Rows.Count
                For i = 0 To rows - 1
                    'database DXCCprefix2 takes East for + but CorceDistance takes West for +
                    If ds.Tables("DXCCprefix2").Rows(i).Item("longitude") <> 0 Or _
                        ds.Tables("DXCCprefix2").Rows(i).Item("latitude") <> 0 Then
                        CourseDistance(ds.Tables("DXCCprefix2").Rows(i).Item("latitude"), _
                                   ds.Tables("DXCCprefix2").Rows(i).Item("longitude") * (-1), _
                                   course, distance)
                        longPath = course + 180
                        If longPath >= 360 Then longPath -= 360
                        LbPrefix.Items.Add(ds.Tables("DXCCprefix2").Rows(i).Item("country") & _
                       ", " & distance.ToString & "km, " & course.ToString & "(" & longPath.ToString & ")")
                    Else
                        LbPrefix.Items.Add(ds.Tables("DXCCprefix2").Rows(i).Item("country"))
                    End If
                Next
                searchDXCC = 0 'serach DONE
            Else
                searchDXCC = 1 'there is an Alias in the DXCC table
            End If
        Else
            searchDXCC = -1 'there is no-entry in the DXCC table
            Debug.Print("search DXCC by " & prefix & ", but no entry in the DXCC table")
        End If
    End Function

    Private Function searchITU(ByVal strPrefix As String, ByRef aliasPrefix As String) As Integer
        'Length of strPrefix must be 3
        Dim code As Integer
        'Dim conDB As New MySqlConnection
        Dim strCond As String
        'Dim prefix As String = ""
        Dim NoMoreAlias As String = ""

        ds.Clear()
        code = Asc(strPrefix) * 10000 + Asc(strPrefix.Substring(1, 1)) * 100 + Asc(strPrefix.Substring(2, 1))
        strCond = "where start <= " & code & " and stop >= " & code
        If DataBaseModule.FillTablePartial(ds, "ITUprefix2", "country, alias", strCond, strConn) = True Then
            aliasPrefix = ds.Tables("ITUprefix2").Rows(0).Item("alias")
            Debug.Print("search ITU by " & strPrefix & ", alias is " & aliasPrefix)
            If aliasPrefix <> "" Then
                searchITU = 1 'there is an alias in the ITU table
            Else
                LbPrefix.Items.Add(ds.Tables("ITUprefix2").Rows(0)("country"))
                searchITU = 0 'find an entry, there is no alias
            End If
        Else
            LbPrefix.Items.Add("Unknown Prefix")
            searchITU = -1 'there is no entry int the ITU table
            Debug.Print("search ITU by " & strPrefix & ", but no entry in the ITU table")
        End If

    End Function


    Private Sub TbPrefix_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles TbPrefix.KeyDown
        Dim aliasPrefix As String = ""
        Dim prefix As String = ""
        Dim NoMoreAlias As String = ""

        Dim status As Integer

        Select Case e.KeyCode
            Case Keys.Enter
                LbPrefix.Items.Clear()
                If TbPrefix.Text.Length = 2 Then
                    status = searchDXCC(TbPrefix.Text, aliasPrefix)

                    If status > 0 Then
                        AstrCheck(aliasPrefix, TbPrefix.Text)
                        prefix = aliasPrefix
                        If searchDXCC(prefix, aliasPrefix) < 0 Then
                            'try ITU table
                            searchITU(prefix & "0", NoMoreAlias)
                        End If
                    ElseIf status < 0 Then
                        status = searchITU(TbPrefix.Text & "0", aliasPrefix)
                        If status > 0 Then
                            AstrCheck(aliasPrefix, TbPrefix.Text)
                            prefix = aliasPrefix
                            If searchDXCC(prefix, aliasPrefix) < 0 Then
                                'try ITU table
                                searchITU(prefix & "0", NoMoreAlias)
                            End If
                        End If
                    End If
                ElseIf TbPrefix.Text.Length = 3 Then
                    status = searchDXCC(TbPrefix.Text, aliasPrefix)

                    If status < 0 Then
                        status = searchDXCC(TbPrefix.Text.Substring(0, 2), aliasPrefix)

                        If status > 0 Then
                            AstrCheck(aliasPrefix, TbPrefix.Text)
                            prefix = aliasPrefix
                            If searchDXCC(prefix, aliasPrefix) < 0 Then
                                'try ITU table
                                prefix = prefix & "0"
                                prefix = prefix.Substring(0, 3)
                                searchITU(prefix, NoMoreAlias)
                            End If
                        ElseIf status < 0 Then
                            status = searchITU(TbPrefix.Text & "0", aliasPrefix)
                            If status > 0 Then
                                AstrCheck(aliasPrefix, TbPrefix.Text)
                                prefix = aliasPrefix
                                If searchDXCC(prefix, aliasPrefix) < 0 Then
                                    'try ITU table
                                    prefix = prefix & "0"
                                    prefix = prefix.Substring(0, 3)
                                    searchITU(prefix, NoMoreAlias)
                                End If
                            End If
                        End If
                    ElseIf status > 0 Then
                        prefix = aliasPrefix
                        status = searchDXCC(prefix, aliasPrefix)
                    End If
                End If
                If LbPrefix.Items.Count = 1 Then
                    setPresetValue(LbPrefix.Items.Item(0))
                End If
            Case Keys.F12
                TbPrefix.Text = ""
                LbPrefix.Items.Clear()
            Case Else

        End Select
    End Sub

    Private Sub TbPrefix_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TbPrefix.KeyPress
        If e.KeyChar = Microsoft.VisualBasic.ChrW(Keys.Enter) OrElse _
             e.KeyChar = Microsoft.VisualBasic.ChrW(Keys.Escape) Then
            e.Handled = True
        End If
    End Sub

    Private Sub CalcCToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CalcCToolStripMenuItem.Click
        Dim distance As Integer
        Dim course As Integer
        Dim conn As New MySqlConnection
        Dim strSQL As String = ""
        Dim id As Integer
        Dim lat As Double
        Dim lon As Double

        If MessageBox.Show("Do you want to Calculate Distance and Course for every DXCC Entity from your location?", "Are you sure?", MessageBoxButtons.YesNo) = DialogResult.No Then
            Exit Sub
        End If

        LbPrefix.Items.Clear()
        If DataBaseModule.Open(conn, strConn) = False Then
            MsgBox("can not open the connection to " & strConn)
            Exit Sub
        End If

        ds.Tables("DXCCprefix2").Clear()
        If DataBaseModule.FillTable(ds, "DXCCprefix2", strConn) Then
            For i = 0 To ds.Tables("DXCCprefix2").Rows.Count - 1
                lat = ds.Tables("DXCCprefix2").Rows(i).Item("latitude")
                lon = ds.Tables("DXCCprefix2").Rows(i).Item("longitude")
                If lat <> 0 Or lon <> 0 Then
                    CourseDistance(lat, lon * (-1), course, distance)
                    id = ds.Tables("DXCCprefix2").Rows(i).Item("id")
                    strSQL = "update DXCCprefix2 set distance = '" & distance.ToString & "', course = '" _
                        & course.ToString & "' where id = '" & id.ToString & "';"
                    ExecuteNonQuery(conn, strSQL)
                End If
            Next i
        End If
        DataBaseModule.Close(conn)
        LbPrefix.Items.Add("Calculation completed")
        LbPrefix.Items.Add(" and Database updated")
    End Sub

    Private Sub endpoint(ByVal radius As Integer, ByVal angle As Integer, ByVal center As Point, ByRef ep As Point)
        Dim kakudo As Integer = (angle - 90) * (-1)
        ep.X = center.X + radius * Cos(Math.PI * kakudo / 180)
        ep.Y = center.Y - radius * Sin(Math.PI * kakudo / 180)
    End Sub

    Private Sub PlotPoint(ByRef g As Graphics, ByVal dis As Integer, _
                          ByVal angle As Integer, ByRef cont As String)

        Dim kakudo As Integer = (angle - 90) * (-1)
        Dim zahyo As New Point
        Dim center As New Point(PbGreatCircle.Width / 2, PbGreatCircle.Height / 2)
        Dim radius As Integer = (PbGreatCircle.Width - 70) / 2
        Dim len As Double


        len = dis * radius / (Math.PI * 6371)
        zahyo.X = center.X + len * Cos(Math.PI * kakudo / 180)
        zahyo.Y = center.Y - len * Sin(Math.PI * kakudo / 180)

        If cont = "AS" Then
            g.FillRectangle(Brushes.Pink, zahyo.X, zahyo.Y, 2, 2)
        ElseIf cont = "EU" Then
            g.FillRectangle(Brushes.Green, zahyo.X, zahyo.Y, 2, 2)
        ElseIf cont = "AF" Then
            g.FillRectangle(Brushes.Maroon, zahyo.X, zahyo.Y, 2, 2)
        ElseIf cont = "NA" Then
            g.FillRectangle(Brushes.Olive, zahyo.X, zahyo.Y, 2, 2)
        ElseIf cont = "SA" Then
            g.FillRectangle(Brushes.Red, zahyo.X, zahyo.Y, 2, 2)
        ElseIf cont = "OC" Then
            g.FillRectangle(Brushes.Navy, zahyo.X, zahyo.Y, 2, 2)
        Else
            g.FillRectangle(Brushes.Black, zahyo.X, zahyo.Y, 2, 2)
        End If

    End Sub


    Private Sub DrawCountries(ByRef g As Graphics)
        'ds.Tables("DXCCprefix2").Clear()
        'If DataBaseModule.FillTable(ds, "DXCCprefix2", strConn) Then
        For i = 0 To ds2.Tables("DXCCprefix2").Rows.Count - 1
            If ds2.Tables("DXCCprefix2").Rows(i).Item("distance") <> 0 Then
                PlotPoint(g, ds2.Tables("DXCCprefix2").Rows(i).Item("distance"), _
                          ds2.Tables("DXCCprefix2").Rows(i).Item("course"), _
                          ds2.Tables("DXCCprefix2").Rows(i).Item("continent"))
            End If
        Next
        'End If
    End Sub

    Private Sub DrawGreatCircle()
        Dim canvas As New Bitmap(PbGreatCircle.Width, PbGreatCircle.Height)
        Dim g As Graphics = Graphics.FromImage(canvas)
        Dim fnt As New Font("MS UI Gothic Bold", 14)

        Dim center As New Point(PbGreatCircle.Width / 2, PbGreatCircle.Height / 2)
        Dim radius As Integer = (PbGreatCircle.Width - 70) / 2
        Dim ep As New Point
        Dim ep1 As New Point
        Dim blackPenBold As New Pen(Color.Black, 5)
        Dim blackPen As New Pen(Color.Black, 3)
        Dim YellowThickPen As New Pen(Color.Cyan, 11)
        Dim RedThinPen As New Pen(Color.Red, 2)
        Dim rad12(12) As Point
        Dim i, j As Integer
        Dim Preset As Integer

        Dim rect1 As New Rectangle(2, 2, PbGreatCircle.Width - 4, PbGreatCircle.Height - 4)
        Dim rect2 As New Rectangle(35, 35, PbGreatCircle.Width - 70, PbGreatCircle.Height - 70)
        g.FillEllipse(Brushes.PapayaWhip, rect1)
        g.DrawEllipse(Pens.Black, rect1)
        g.FillEllipse(Brushes.Azure, rect2)
        g.DrawEllipse(Pens.Black, rect2)
        'write guraduation mark
        For i = 0 To 359 Step 10
            endpoint(radius - 20, i, center, ep1)
            endpoint(radius - 2, i, center, ep)
            g.DrawLine(blackPen, ep1, ep)
        Next i
        j = 0
        For i = 0 To 359 Step 30
            endpoint(radius - 30, i, center, ep1)
            endpoint(radius, i, center, ep)
            rad12(j) = ep
            j += 1
            g.DrawLine(blackPenBold, ep1, ep)
        Next i
        'write figures of angle 30 deg. step
        g.DrawString("0", fnt, Brushes.Blue, rad12(0).X - 8, rad12(0).Y - 24)
        g.DrawString("30", fnt, Brushes.Blue, rad12(1).X - 4, rad12(1).Y - 22)
        g.DrawString("60", fnt, Brushes.Blue, rad12(2).X, rad12(2).Y - 18)
        g.DrawString("90", fnt, Brushes.Blue, rad12(3).X + 2, rad12(3).Y - 12)
        g.DrawString("120", fnt, Brushes.Blue, rad12(4).X - 2, rad12(4).Y - 6)
        g.DrawString("150", fnt, Brushes.Blue, rad12(5).X - 8, rad12(5).Y)
        g.DrawString("180", fnt, Brushes.Blue, rad12(6).X - 18, rad12(6).Y + 2)
        g.DrawString("210", fnt, Brushes.Blue, rad12(7).X - 28, rad12(7).Y)
        g.DrawString("240", fnt, Brushes.Blue, rad12(8).X - 34, rad12(8).Y - 6)
        g.DrawString("270", fnt, Brushes.Blue, rad12(9).X - 36, rad12(9).Y - 12)
        g.DrawString("300", fnt, Brushes.Blue, rad12(10).X - 34, rad12(10).Y - 18)
        g.DrawString("330", fnt, Brushes.Blue, rad12(11).X - 28, rad12(11).Y - 22)

        DrawCountries(g)
        endpoint(radius - 35, Azimuth, center, ep)
        g.DrawLine(YellowThickPen, center, ep)
        g.DrawLine(Pens.White, center, ep)
        If TbPreset.Text.Length > 0 Then
            Preset = Integer.Parse(TbPreset.Text)
            endpoint(radius, Preset, center, ep)
            g.DrawLine(RedThinPen, center, ep)
        End If

        fnt.Dispose()
        g.Dispose()
        'write an image
        PbGreatCircle.Image = canvas
    End Sub

    Private Function extractDir(ByVal str As String) As Integer
        Dim index1, index2 As Integer
        extractDir = -1

        Try
            index1 = str.IndexOf("km, ")
            index2 = str.IndexOf("(")
            If index1 > 0 And index2 > 0 Then
                str = str.Substring(0, index2)
                str = str.Substring(index1 + 4)
                extractDir = Integer.Parse(str)
            End If
        Catch ex As Exception
            Debug.Print(ex.ToString & " in extractDir")
        End Try
    End Function

    Private Sub setPresetValue(ByVal strLbLine As String)
        Dim dir As Integer = extractDir(strLbLine)
        If dir >= 0 Then
            TbPreset.Text = dir.ToString
            DrawGreatCircle()
        End If
    End Sub

    Private Sub LbPrefix_DoubleClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LbPrefix.DoubleClick
        setPresetValue(LbPrefix.SelectedItem)
    End Sub

    Private Sub Form1_Resize(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        Dim resize As Size
        Dim width, height As Integer
        width = Me.Size.Width - Panel1.Size.Width - 20
        height = Panel1.Size.Height

        If width > height Then
            width = height
        Else
            height = width
        End If
        resize.Width = width
        resize.Height = height
        PbGreatCircle.Size = resize
    End Sub

    Private Sub MyLocationMToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyLocationMToolStripMenuItem.Click
        Form2.TbMyCall.Text = ds2.Tables("MyLocation").Rows(0).Item("MyCall")
        Form2.TbLatitude.Text = ds2.Tables("MyLocation").Rows(0).Item("latitude")
        Form2.TbLongitude.Text = ds2.Tables("MyLocation").Rows(0).Item("longitude")
        Form2.ShowDialog()
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        COMPort.Write("D")
    End Sub

    Sub ModifyAzimuth()
        Dim temp As String = ""
        Dim overlap As Integer
        Dim motor As Integer

        Try
            'Debug.Print("strAzimuth = " & strAzimuth)
            Azimuth = Integer.Parse(strAzimuth)
            motor = Azimuth Mod 10
            Azimuth = Azimuth \ 10
            lblAzimuth.Text = Azimuth.ToString
            If Azimuth >= 360 Then
                overlap = Azimuth - 360
                lblAz2.Text = "(" & overlap.ToString & ")"
                lblAz2.Visible = True
            Else
                lblAz2.Visible = False
            End If
            If motor = 1 Then 'CW
                btnCW.BackColor = Color.LimeGreen
                btnCCW.BackColor = Color.Silver
            ElseIf motor = 2 Then 'CCW
                btnCCW.BackColor = Color.LimeGreen
                btnCW.BackColor = Color.Silver
            Else
                btnCW.BackColor = Color.Silver
                btnCCW.BackColor = Color.Silver
            End If

            TxbRx.AppendText(strAzimuth & vbCrLf)
            If Len(TxbRx.Text) > (TxbRx.MaxLength - 1000) Then
                'remove half data when it became too large
                temp = Mid(TxbRx.Text, TxbRx.MaxLength / 2, Len(TxbRx.Text))
                TxbRx.Text = temp
            End If

            DrawGreatCircle()
        Catch ex As Exception
            Debug.Print(ex.Message & "in ModifyAzimuth")
        End Try

    End Sub

    Private Sub COMPort_DataReceived(ByVal sender As System.Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles COMPort.DataReceived
        Dim ModAzi As New ModifyAzimuthLabel(AddressOf ModifyAzimuth)
        Try
            strAzimuth = COMPort.ReadLine()
            Debug.Print("data received: " & strAzimuth)
            lblAzimuth.Invoke(ModAzi)
        Catch ex As Exception
            Debug.Print(ex.Message & vbCrLf & "RxBufLength = " & RxBufLength.ToString)
        End Try
    End Sub

    Private Sub btnCW_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCW.Click
        COMPort.Write("A")
    End Sub

    Private Sub btnCCW_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCCW.Click
        COMPort.Write("B")
    End Sub

    Private Sub btnSTOP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSTOP.Click
        COMPort.Write("C")
    End Sub

    Private Sub btnStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStart.Click
        Dim preset As Integer
        Try
            preset = Integer.Parse(TbPreset.Text)
            COMPort.Write(preset.ToString("D3") & "E")
        Catch ex As Exception
            MsgBox("Invalid Preset Value")
            Debug.Print(ex.Message & "in btnPrest")
        End Try
    End Sub

    Private Sub EixtXToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EixtXToolStripMenuItem.Click
        Me.Close()
    End Sub

    Private Sub TbPreset_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles TbPreset.KeyDown
        Dim direction As Integer
        Try
            If TbPreset.Text.Length > 0 Then
                direction = Integer.Parse(TbPreset.Text)

                Select Case e.KeyCode
                    Case Keys.Up
                        If direction > 180 Then
                            direction -= 180
                        Else
                            direction += 180
                        End If
                        TbPreset.Text = direction.ToString
                    Case Keys.Down
                        If direction > 180 Then
                            direction -= 180
                        Else
                            direction += 180
                        End If
                        TbPreset.Text = direction.ToString
                End Select
            End If
        Catch ex As Exception
            Debug.Print("exception in TbPreset_KeyDown: " & ex.Message)
        End Try
    End Sub

    Private Sub AboutAToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AboutAToolStripMenuItem.Click
        MsgBox("RotatorController2" & vbCrLf & "  version 1.0" & "  2013.12.21")
    End Sub
End Class
